"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AmpVariantClassification(ProtocolElement):
    """
    Full Variant classification acording to AMP guideline, including all
    supporting evidences and the final     assessment
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "ampEvidences",
        "ampTier",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_3 import reports as reports_6_1_0

        return {
            "ampClincialOrExperimentalEvidence": reports_6_1_0.AmpClincialOrExperimentalEvidence,
            "ampEvidences": reports_6_1_0.AmpEvidence,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_3 import reports as reports_6_1_0

        return {
            "ampTier": reports_6_1_0.AmpTier,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_3 import reports as reports_6_1_0

        return {
            "org.gel.models.report.avro.AmpClincialOrExperimentalEvidence": reports_6_1_0.AmpClincialOrExperimentalEvidence,
            "org.gel.models.report.avro.AmpEvidence": reports_6_1_0.AmpEvidence,
            "org.gel.models.report.avro.AmpTier": reports_6_1_0.AmpTier,
            "org.gel.models.report.avro.AmpVariantClassification": reports_6_1_0.AmpVariantClassification,
        }

    __slots__ = [
        "ampEvidences",
        "ampTier",
        "ampClincialOrExperimentalEvidence",
        "assessment",
    ]

    def __init__(
        self,
        ampEvidences,
        ampTier,
        ampClincialOrExperimentalEvidence=None,
        assessment=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_1_0.AmpVariantClassification model.

        :param ampEvidences:
            List of AMP evidences
        :type ampEvidences: list[AmpEvidence]
        :param ampTier:
            Final Clasification taken in account the evidences
        :type ampTier: AmpTier
        :param ampClincialOrExperimentalEvidence:
            Clinical or Experimental evicence
        :type ampClincialOrExperimentalEvidence: None | list[AmpClincialOrExperimentalEvidence]
        :param assessment:
            Final Assessment
        :type assessment: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.1.0"
